using System;
using System.Web.UI.WebControls;
using System.Web.UI;
using System.ComponentModel;

namespace Interval.BubbledEvents2
{
	
	/// <summary>
	/// CheckBox, kter bubl udlost <see cref="CheckedChanged"/>
	/// </summary>
	public class CheckBoxEx : CheckBox
	{
		#region Constructors
		/// <summary>
		///Standardn konstruktor
		/// </summary>
		public CheckBoxEx() : base()
		{

		}
		#endregion Constructors

		#region Public properties
		/// <summary>
		/// Nzev pkazu, jen identifikuje bublanou udlost
		/// </summary>
		[Category("Behavior")]
		public virtual string CommandName
		{
			get
			{
				string commandName = (string) ViewState["CommandName"];
				if (commandName != null)
					return commandName;

				return String.Empty;
			}
			set
			{
				ViewState["CommandName"] = value;
			}
		}

		/// <summary>
		/// Dodaten informace k bublan udlosti
		/// </summary>
		[Category("Behavior")]
		[Bindable(true)]
		public virtual string CommandArgument
		{
			get
			{
				string commandArgument = (string) ViewState["CommandArgument"];
				if (commandArgument != null)
					return commandArgument;

				return String.Empty;
			}
			set
			{
				ViewState["CommandArgument"] = value;
			}
		}

		#endregion Public properties
		
		#region Protected methods
		/// <summary>
		/// Metoda pro vyvoln udlosti <see cref="CheckedChanged"/>
		/// </summary>
		/// <param name="e">Argumenty udlosti</param>
		/// <remarks>Po zavoln implementace metody z bzov tdy je udlost <see cref="CheckedChanged"/> bublna </remarks>
		protected override void OnCheckedChanged(EventArgs e)
		{
			base.OnCheckedChanged(e);
			RaiseBubbleEvent(this, new CommandEventArgs(this.CommandName, this.CommandArgument));
		}

		#endregion Protected methods

	}
}
